/*
 * 消息模板
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.BsModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MsgTemplateController : BaseController
    {
        public MsgTemplateController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["BsSqlConnStr"].ToString();
        }

        #region 消息模板列表

        /// <summary>
        /// 根据条件查询消息模板列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MsgTemplate data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "Title:\"" + data.Title + "\",";
Condition += "ColId:\"" + data.ColId + "\",";
Condition += "TemplateType:\"" + data.TemplateType + "\",";
Condition += "MsgType:\"" + data.MsgType + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询消息模板列表

        /// <summary>
        /// 消息模板列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MsgTemplate data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("Title", "2"); //标题
Fields.Add("ColId", "1"); //分类
Fields.Add("TemplateType", "1"); //类型
Fields.Add("MsgType", "1"); //消息类型

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgTemplate", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ColId"] = RelationClass.GetColInfo(dic["ColId"].ToString());

            }
            return Json(obj);
        }

        #endregion

        #region 增加消息模板

        /// <summary>
        /// 增加或修改消息模板信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加消息模板

        /// <summary>
        /// 增加或修改消息模板信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MsgTemplate data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("Title", data.Title); //标题
Fields.Add("ColId", data.ColId); //分类
Fields.Add("TemplateType", data.TemplateType); //类型
Fields.Add("MsgType", data.MsgType); //消息类型

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Add("MsgTemplate", Fields, 0);
            AddSysLog(data.Id.ToString(), "MsgTemplate", "add");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改消息模板

        /// <summary>
        /// 增加或修改消息模板信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            MsgTemplate editData = bsdb.MsgTemplate.FirstOrDefault(m => m.Id == Id) ?? new MsgTemplate();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改消息模板

        /// <summary>
        /// 增加或修改消息模板信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MsgTemplate data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("Title", data.Title); //标题
Fields.Add("ColId", data.ColId); //分类
Fields.Add("TemplateType", data.TemplateType); //类型
Fields.Add("MsgType", data.MsgType); //消息类型

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgTemplate", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MsgTemplate","update");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除消息模板信息

        /// <summary>
        /// 删除消息模板信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgTemplate","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgTemplate", Fields, id);
            }
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgTemplate","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgTemplate", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgTemplate","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgTemplate", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Sort("MsgTemplate", Sort, Id);
            
            AddSysLog(Id.ToString(), "MsgTemplate", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                bsdb.MsgTemplate.Add(new MsgTemplate()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                bsdb.SaveChanges();
            }
            AddSysLog("0", "MsgTemplate", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MsgTemplate data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "2"); //标题
Fields.Add("ColId", "1"); //分类
Fields.Add("TemplateType", "1"); //类型
Fields.Add("MsgType", "1"); //消息类型

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgTemplate", Fields, "Id desc", "0", 1, 20000, "", "Content,Remark", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ColId"] = RelationClass.GetColInfo(dic["ColId"].ToString());

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("Content", "内容");
ReturnFields.Add("Remark", "注释");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MsgTemplate", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
